SystemOrganization addCategory: #'Gitocello-GST'!
SystemOrganization addCategory: #'Gitocello-Morphic'!
SystemOrganization addCategory: #'Gitocello-Core'!

!MCWorkingCopyBrowser methodsFor: '*gitocello-actions-override' stamp: 'TF 5/15/2010 18:00:57.1'!
saveVersion
	| repo |
	self canSave ifFalse: [^self].
	self checkForNewerVersions ifFalse: [^self].
	repo := self repository.
	workingCopy newVersion ifNotNil:
		[:v |
		(MCVersionInspector new version: v) show.
		Cursor wait showWhile: [repo storeVersion: v].
		MCCacheRepository default cacheAllFileNamesDuring: 
			[repo cacheAllFileNamesDuring: 
				[v allAvailableDependenciesDo:
					[:dep |
					(repo includesVersionNamed: dep info name)
						ifFalse: [repo storeVersion: dep]]]].
		(GCRegistry tracksPackage: workingCopy package)
			ifTrue: [GCRegistry storeVersion: workingCopy].
		].! !

!MCWorkingCopyBrowser methodsFor: '*gitocello' stamp: 'tfel 9/10/2009 09:20'!
trackWithGit

	GCRegistry createRepositoryFor: workingCopy package name! !

!MCWorkingCopyBrowser methodsFor: '*gitocello' stamp: 'tfel 9/10/2009 09:24'!
untrackWithGit

	GCRegistry removeRepositoryFor: workingCopy package name! !

!MCWorkingCopyBrowser methodsFor: '*gitocello-morphic ui-override' stamp: 'tfel 9/10/2009 09:27'!
workingCopyListMenu: aMenu
	workingCopy ifNil: [^ aMenu].
	self fillMenu: aMenu fromSpecs:
		#(('add required package' #addRequiredPackage)
			('clear required packages' #clearRequiredPackages)
			('browse package' #browseWorkingCopy)
			('view changes' #viewChanges)
			('view history' #viewHistory)
			('recompile package' #recompilePackage)
			('revert package...' #revertPackage)
			('unload package' #unloadPackage)
			('delete working copy' #deleteWorkingCopy)).
	(Smalltalk includesKey: #SARMCPackageDumper) ifTrue: [
		aMenu add: 'make SAR' target: self selector: #fileOutAsSAR
	].
	(GCRegistry tracksPackage: workingCopy package)
		ifFalse: [aMenu add: 'track with Git' target: self selector: #trackWithGit]
		ifTrue: [aMenu add: 'untrack with Git' target: self selector: #untrackWithGit].
	^aMenu! !

Object subclass: #GCGitWrapper
	instanceVariableNames: 'localPath'
	classVariableNames: 'CalloutDict GitBinaryPath'
	poolDictionaries: ''
	category: 'Gitocello-Core'!

!GCGitWrapper class methodsFor: 'callout' stamp: 'tfel 5/31/2010 15:42:45.566'!
apiLinuxLibc5Callout: aCommand
	<cdecl: long 'system' ( char* ) module: 'libc.so.5'>
	^ self externalCallFailed ! !

!GCGitWrapper class methodsFor: 'callout' stamp: 'tfel 5/31/2010 15:43:23.198'!
apiLinuxLibc6Callout: aCommand
	<cdecl: long 'system' ( char* ) module: 'libc.so.6'>
	^ self externalCallFailed ! !

!GCGitWrapper class methodsFor: 'callout' stamp: 'tfel 5/31/2010 15:43:35.167'!
apiMacOSXCallout: aCommand
	<cdecl: long 'system' (char*) module: 'libSystem.dylib'>
	| errCode |
	errCode := ExternalFunction getLastError. 
	^ errCode = 13 "Unable to find function address. dylibs are not searched"
		ifTrue: [self error: 'Cannot call libSystem.dylib. 
			Please set "SqueakPluginsBuiltInOrLocalOnly" in your VM''s Info.plist to false']
		ifFalse: [self externalCallFailed]! !

!GCGitWrapper class methodsFor: 'callout' stamp: 'tfel 5/31/2010 15:43:55.31'!
apiWindowsCallout: aCommand
	<apicall: long 'system' ( char* ) module: 'msvcrt.dll'>
	^ self externalCallFailed! !

!GCGitWrapper class methodsFor: 'callout' stamp: 'tfel 5/31/2010 15:44:05.438'!
callout: aCommand

	(self calloutDict 
		at: SmalltalkImage current platformName asLowercase
		ifAbsent: [[:cmd | self error: 'Not implemented for your platform!!']]) 
			value: aCommand.! !

!GCGitWrapper class methodsFor: 'callout' stamp: 'tfel 5/31/2010 15:41:53.537'!
calloutDict

	CalloutDict ifNil: [CalloutDict := Dictionary new
		at: 'unix' put: [:cmd | self linuxCallout: cmd];
		at: 'win32' put: [:cmd | self windowsCallout: cmd];
		at: 'mac os' put: [:cmd | self apiMacOSXCallout: cmd];
		yourself].
	^ CalloutDict! !

!GCGitWrapper class methodsFor: 'preferences' stamp: 'tfel 5/31/2010 15:38:12.485'!
gitBinaryPath

	<preference: 'Git binary path'
		category: 'Gitocello'
		description: 'Set the path of the git binary to be used for Gitocello'
		type: #String>
	^ GitBinaryPath ifNil: ['git']
! !

!GCGitWrapper class methodsFor: 'preferences' stamp: 'tfel 5/31/2010 15:46:01.724'!
gitBinaryPath: aString

	GitBinaryPath := aString.! !

!GCGitWrapper class methodsFor: 'callout' stamp: 'tfel 5/31/2010 15:44:11.901'!
linuxCallout: aCommand
	"Try with new libc6 and older libc5"
	[self apiLinuxLibc6Callout: aCommand] 
		on: Error
		do: [self apiLinuxLibc5Callout: aCommand]! !

!GCGitWrapper class methodsFor: 'callout' stamp: 'tfel 5/31/2010 15:44:16.653'!
windowsCallout: aCommand
	"Escape newlines for Windows CmdLine"
	| escapedCommand |
	escapedCommand := ((aCommand 
		copyReplaceAll: Character cr asString with: ' ') 
			copyReplaceAll: Character lf asString with: ' ').
	self apiWindowsCallout: escapedCommand.! !

!GCGitWrapper methodsFor: 'commands' stamp: 'tfel 9/8/2009 20:00'!
add
	"Just add all"
	self gitCommand: 'add .'! !

!GCGitWrapper methodsFor: 'commands' stamp: 'tfel 9/8/2009 20:00'!
add: matchString
	"Add using matchString"
	self gitCommand: 'add ', matchString! !

!GCGitWrapper methodsFor: 'commands' stamp: 'tfel 9/8/2009 20:00'!
commit: commitMsg
	"Commit changes to the local repository"
	self gitCommand: 'commit -m "',  commitMsg, '"'! !

!GCGitWrapper methodsFor: 'commands' stamp: 'mh 5/12/2010 17:03'!
dirChangeCommand
	^ SmalltalkImage current platformName asLowercase = 'win32'
		ifTrue: ['cd "', self localPath, '" & ', (self localPath copyUpTo: $:) ,': & ']
		ifFalse: ['cd "', self localPath, '";'].
		! !

!GCGitWrapper methodsFor: 'commands' stamp: 'tfel 5/31/2010 15:44:47.677'!
gitCommand: aCommandString
	"Enter the local repository and run the 'git' command with the parameters"
	| command |
	command := self dirChangeCommand, ' ', self class gitBinaryPath, ' ', aCommandString.
	(Smalltalk classNamed: 'OSProcess')
		ifNil: [self class callout: command]
		ifNotNilDo: [:class | class waitForCommand: command].! !

!GCGitWrapper methodsFor: 'commands' stamp: 'tfel 9/7/2009 01:03'!
init

	self gitCommand: 'init'! !

!GCGitWrapper methodsFor: 'accessing' stamp: 'tfel 9/6/2009 23:10'!
localPath
	"Answer the value of localPath"

	^ localPath! !

!GCGitWrapper methodsFor: 'accessing' stamp: 'tfel 9/6/2009 23:10'!
localPath: anObject
	"Set the value of localPath"

	localPath := anObject! !

!GCGitWrapper methodsFor: 'commands' stamp: 'tfel 9/7/2009 03:29'!
origin: aRemoteUrl

	self gitCommand: 'remote rm origin'.
	self gitCommand: 'remote add origin ', aRemoteUrl! !

!GCGitWrapper methodsFor: 'commands' stamp: 'TF 5/15/2010 17:59:40.669'!
pull
	"Avoid merging altogether for now"
	self gitCommand: 'pull -s ours origin master'! !

!GCGitWrapper methodsFor: 'commands' stamp: 'tfel 9/6/2009 18:30'!
push

	self gitCommand: 'push origin master'! !

Object subclass: #GCGstConvertCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Gitocello-GST'!

!GCGstConvertCommand commentStamp: 'tfel 9/10/2009 11:48' prior: 0!
I am used for converting a Squeak source file to Gnu Smalltalk syntax using the gst-convert tool with the options found at http://smalltalk.gnu.org/faq/169!

!GCGstConvertCommand class methodsFor: 'private' stamp: 'tfel 9/14/2009 01:01'!
allMethodsIn: aCategory

	^ ((self class methodDictionary asSet select: [:msg |
		(msg methodClass organization categoryOfElement: msg selector) asString = aCategory])
			collect: [:each | each selector]) asArray! !

!GCGstConvertCommand class methodsFor: 'bidirectional-rules' stamp: 'tfel 9/14/2009 01:10'!
classNames

	^ {	'Float' -> 'FloatD' .
		'BlockContext' -> 'BlockClosure' .
		'MessageSend' -> 'DirectedMessage' .
		'DateAndTime' -> 'DateTime' .
		'UnhandledError' -> 'SystemExceptions.UnhandledException' .
	    }! !

!GCGstConvertCommand class methodsFor: 'command-building' stamp: 'tfel 11/16/2009 20:36'!
commandLineFor: aFilepath from: input to: output
	"see http://smalltalk.gnu.org/faq/169 for info on gst-convert command-line"
	| stream |
	stream := WriteStream on: (String new: 1000).
	stream nextPutAll: 'gst-convert -f ', input, ' '."-F ', output, ' '."
	(self allMethodsIn: input, '-to-', output, '-rules')
			do: [:method | self writeRules: (self perform: method) to: stream].
	self 
		flip: (self perform: (input, 'Newline') asSymbol) 
		with: (self perform: (output, 'Newline') asSymbol)
		on: aFilepath in: stream.
	^ stream contents
! !

!GCGstConvertCommand class methodsFor: 'actions' stamp: 'TF 5/9/2010 15:17'!
convert: aFilepath from: input to: output

	| filename cmdline |
	cmdline := self commandLineFor: aFilepath from: input to: output.
	(Smalltalk classNamed: 'OSProcess') 
		ifNil: [Transcript show: cmdline; cr.]
		ifNotNilDo: [:class |
			class waitForCommand: (cmdline).
			filename := FileDirectory localNameFor: aFilepath.
			FileDirectory deleteFilePath: aFilepath.
			(FileDirectory forFileName: aFilepath) 
				rename: filename, '.converted' toBe: filename].! !

!GCGstConvertCommand class methodsFor: 'command-building' stamp: 'tfel 9/13/2009 13:22'!
flip: aString with: anotherString on: aFilepath in: aStream

	aStream 
		nextPutAll: '"', aFilepath, '"';
		nextPutAll: ' - | tr ', aString, ' ', anotherString, ' > ';
		nextPutAll: '"', aFilepath, '.converted"'
! !

!GCGstConvertCommand class methodsFor: 'gst-to-squeak-rules' stamp: 'tfel 9/14/2009 00:52'!
gstBidirectional
	"Reverse all bidirectional rules to apply them for squeak -> gst conversion"
	^ (self allMethodsIn: 'bidirectional-rules')
		inject: OrderedCollection new
		into: [:list :method | 
			list union: ((self perform: method) 
						collect: [:each | each value -> each key])]! !

!GCGstConvertCommand class methodsFor: 'literals' stamp: 'tfel 9/13/2009 11:42'!
gstNewline

	^ '\\n'! !

!GCGstConvertCommand class methodsFor: 'bidirectional-rules' stamp: 'tfel 9/14/2009 01:13'!
methodNames

	^ {	'Date current' -> 'Date today' .
		'TimeStamp current' -> 'DateTime now' .
		'FileDirectory pathNameDelimiter' -> 'Directory pathSeparator' .
		'FileDirectory default' -> 'Directory working' .
		'(FileDirectory deleteFilePath: ``@arg2)' -> '(File remove: ``@arg2)' .
		'(FileDirectory localNameFor: ``@arg2)' -> '(FilePath stripPathFrom: ``@arg2)' .
		'(``@object recursiveDelete)' -> '(``@object all remove)' .
		'(``@object pathName)' -> '(``@object name)' .
		'(``@object containingDirectory)' -> '(``@object parent)' .
		'(``@object assureExistence)' -> '(``@object createDirectories)' .
		'(``@object fileExists: ``@arg2)' -> '(``@object / ``@arg2) exists' .
		'(FileDirectory on: ``@arg2)' -> '(``@arg2 asFile)' .
		'(``@object directoryNamed: ``@arg2)' -> '(``@object / ``@arg2)' .
		'(``@object readOnlyFileNamed: ``@arg2)' -> '(``@object / ``@arg2) readStream' .
		'(``@object forceNewFileNamed: ``@arg2)' -> '(``@object / ``@arg2) writeStream' .
		'(``@object allSubInstancesDo: ``@arg2)' -> '(``@object allSubinstancesDo: ``@arg2)' .
		'(``@object newFrom: ``@arg2)' -> '(``@object from: ``@arg2)' .
		'((``@object methodClass organization categoryOfElement: ``@object selector))' -> '(``@object methodCategory)'
	    }! !

!GCGstConvertCommand class methodsFor: 'squeak-to-gst-rules' stamp: 'tfel 9/14/2009 00:52'!
squeakBidirectional
	"Find all bidirectional rules to include them in the conversion"
	^ (self allMethodsIn: 'bidirectional-rules')
		inject: OrderedCollection new
		into: [:list :method | list union: (self perform: method)]! !

!GCGstConvertCommand class methodsFor: 'squeak-to-gst-rules' stamp: 'tfel 9/13/2009 10:36'!
squeakClassNames

	^ {	'TimeStamp' -> 'DateTime' .
		'ProtoObject' -> 'nil' .
	    }! !

!GCGstConvertCommand class methodsFor: 'squeak-to-gst-rules' stamp: 'tfel 9/14/2009 01:24'!
squeakMethodNames

	^ {	'(``@object caseInsensitiveLessOrEqual: ``@arg2)' -> '(``@object <= ``@arg2)' .
		'(``@object isZero)' -> '(``@object = 0)' .
		'FileDirectory dot' -> '($. printString)' .
		'(``@object directoryExists: ``@arg2)' -> '(File path: ``@arg2) exists' .
		'(``@object union: ``@arg1)' -> '(``@object asSet addAll: ``@arg1; yourself)' .
		'FileStream st' -> '($s printString, $t printString)' .
		'(``@object beginsWith: ``@arg2)' -> '(``@object startsWith: ``@arg2)' .
		'(``@object ifNil: ``@arg1 ifNotNilDo: ``@arg2)' -> '(``@object ifNil: ``@arg1 ifNotNil: ``@arg2)' .
		'(``@object ifNotNilDo: ``@arg2 ifNil: ``@arg1)' -> '(``@object ifNotNil: ``@arg2 ifNil: ``@arg1)' .
		'(``@object ifNotNilDo: ``@arg2)' -> '(``@object ifNotNil: ``@arg2)' .
		'(``@object doIfNotNil: ``@arg2)' -> '(``@object ifNotNil: ``@arg2)' .
	    }! !

!GCGstConvertCommand class methodsFor: 'literals' stamp: 'tfel 9/13/2009 11:42'!
squeakNewline

	^ '\\r'! !

!GCGstConvertCommand class methodsFor: 'squeak-to-gst-rules' stamp: 'tfel 9/13/2009 13:13'!
squeakStatements

	^ {	'(``@object and: ``@arg1 and: ``@arg2)' -> '((``@object and: ``@arg1) and: ``@arg2)' .
	    }! !

!GCGstConvertCommand class methodsFor: 'bidirectional-rules' stamp: 'tfel 9/13/2009 13:04'!
statements

	^ {	'(``@object ifNil: ``@arg ifNotNil: [ | `@t2 | `@.s2 ])' -> '(``@object ifNil: ``@arg ifNotNil: [ :foo || `@t2 | `@.s2 ])' .
		'(``@object ifNotNil: [ | `@t2 | `@.s2 ] ifNil: ``@arg)' -> '(``@object ifNotNil: [ :foo || `@t2 | `@.s2 ] ifNil: ``@arg)' .
		'(``@object ifNotNil: [ | `@t2 | `@.s2 ])' -> '(``@object ifNotNil: [ :foo || `@t2 | `@.s2 ])' .
	    }! !

!GCGstConvertCommand class methodsFor: 'command-building' stamp: 'tfel 9/13/2009 19:59'!
writeRules: someRules to: aStream

	someRules do: [:each |
		aStream 
			nextPutAll: '-r';
			nextPut: $';
			nextPutAll: (each printString copyWithout: $'); 
			nextPut: $';
			nextPut: Character space]! !

Object subclass: #GCGstPackageWriter
	instanceVariableNames: 'packageName packageXmlStream newline repoDir'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Gitocello-GST'!

!GCGstPackageWriter commentStamp: 'tfel 9/8/2009 20:24' prior: 0!
I am very specific to GNU Smalltalk integration, as I write the package.xml file required to create GNU Smalltalk *.star format package files.
For now I honour dependencies as set in Monticello and simply file in all the classes in the package at once.
I will at some stage be able to properly handle test cases, which will make porting so much easier.!

!GCGstPackageWriter class methodsFor: 'instance creation' stamp: 'tfel 4/25/2010 16:52:37.173'!
newFor: aPackage

	^ self new
		packageName: aPackage;
		yourself! !

!GCGstPackageWriter methodsFor: 'stream-writing' stamp: 'tfel 4/25/2010 17:13:51.474'!
classFilePathFor: aClass
	"Find the path to the classes fileOut"
	| subfolder |
	subfolder := (aClass theNonMetaClass category asString findBetweenSubStrs: '-') last.
	^ subfolder, FileDirectory pathNameDelimiter asString, 
		aClass name asString, FileDirectory dot, FileStream st! !

!GCGstPackageWriter methodsFor: 'stream-writing' stamp: 'tfel 9/20/2009 13:07'!
classes

	^ (GCRegistry at: self packageName) packageClasses! !

!GCGstPackageWriter methodsFor: 'stream-writing' stamp: 'tfel 9/10/2009 14:14'!
createPackageXml

	self packageXmlStream reset.
	self 
		preamble;
		requires;
		tests;
		fileIns;
		files.
	self packageXmlStream nextPutAll: self postfix! !

!GCGstPackageWriter methodsFor: 'stream-writing' stamp: 'tfel 9/10/2009 14:17'!
fileIn: aClass

	self putAttribute: 'filein' with: (self classFilePathFor: aClass)! !

!GCGstPackageWriter methodsFor: 'stream-writing' stamp: 'tfel 9/10/2009 14:17'!
fileIns

	self classes 
		reject: [:class | class allSuperclasses includes: TestCase]
		thenDo: [:class | self fileIn: class]! !

!GCGstPackageWriter methodsFor: 'fileOut' stamp: 'tfel 9/20/2009 15:22'!
fileOutPackageXml

	| fileName converter file |
	self createPackageXml.
	self packageXmlStream contents isAsciiString 
		ifTrue: [converter := MacRomanTextConverter new]
		ifFalse: [converter := UTF8TextConverter new].
	fileName := self repoDir, FileDirectory pathNameDelimiter asString, 'package.xml'.
	FileDirectory deleteFilePath: fileName.
	file := MultiByteFileStream new open: fileName forWrite: true.
	file 	ifNil: [self error: 'Cannot open file'].
	file text;
		converter: converter;
		nextPutAll: packageXmlStream contents;
		close! !

!GCGstPackageWriter methodsFor: 'stream-writing' stamp: 'tfel 9/10/2009 14:15'!
files

	self classes do: [:class | 
		self 
			putAttribute: 'file' 
			with: (self classFilePathFor: class)
	]! !

!GCGstPackageWriter methodsFor: 'initialize-release' stamp: 'tfel 9/7/2009 21:32'!
initialize

	super initialize.
	newline := Character lf. "This should be configurable"
	self packageXmlStream: (WriteStream on: (String new: 100))! !

!GCGstPackageWriter methodsFor: 'accessing' stamp: 'tfel 9/7/2009 21:25'!
newline
	"Answer the value of newline"

	^ newline! !

!GCGstPackageWriter methodsFor: 'accessing' stamp: 'tfel 9/7/2009 21:25'!
newline: anObject
	"Set the value of newline"

	newline := anObject! !

!GCGstPackageWriter methodsFor: 'accessing' stamp: 'tfel 9/7/2009 20:47'!
packageName
	"Answer the value of packageName"

	^ packageName! !

!GCGstPackageWriter methodsFor: 'accessing' stamp: 'tfel 9/7/2009 20:47'!
packageName: anObject
	"Set the value of packageName"

	packageName := anObject! !

!GCGstPackageWriter methodsFor: 'accessing' stamp: 'tfel 9/7/2009 20:47'!
packageXmlStream
	"Answer the value of packageXmlStream"

	^ packageXmlStream! !

!GCGstPackageWriter methodsFor: 'accessing' stamp: 'tfel 9/7/2009 20:47'!
packageXmlStream: anObject
	"Set the value of packageXmlStream"

	packageXmlStream := anObject! !

!GCGstPackageWriter methodsFor: 'literals' stamp: 'tfel 9/7/2009 20:55'!
postfix

	^ '</package>'! !

!GCGstPackageWriter methodsFor: 'stream-writing' stamp: 'tfel 9/10/2009 14:32'!
preamble

	{'<package>' . '<!!-- THIS FILE IS GENERATED!! EDITS _WILL_ BE LOST ON UPDATE!! -->'. ''}
		do: [:s | self packageXmlStream nextPutAll: s]
		separatedBy: [self packageXmlStream nextPut: newline].
	self 
		putAttribute: 'name' with: self packageName;
		putAttribute: 'namespace' with: self packageName.! !

!GCGstPackageWriter methodsFor: 'stream-writing' stamp: 'tfel 9/10/2009 13:58'!
putAttribute: anXmlAttribute with: someContent

	self packageXmlStream
		nextPutAll: '<', anXmlAttribute, '>';
		nextPutAll: someContent;
		nextPutAll: '</', anXmlAttribute, '>';
		nextPut: newline
		! !

!GCGstPackageWriter methodsFor: 'accessing' stamp: 'tfel 9/7/2009 21:25'!
repoDir
	"Answer the value of repoDir"

	^ repoDir! !

!GCGstPackageWriter methodsFor: 'accessing' stamp: 'tfel 9/7/2009 21:28'!
repoDir: aDirectory
	"Set the value of repoDir"

	aDirectory isString
		ifTrue: [repoDir := aDirectory]
		ifFalse: [repoDir := aDirectory pathName]! !

!GCGstPackageWriter methodsFor: 'stream-writing' stamp: 'tfel 9/7/2009 20:58'!
require: aPackage

	self packageXmlStream
		nextPutAll: '<prereq>';
		nextPutAll: aPackage;
		nextPutAll: '</prereq>';
		nextPut: newline! !

!GCGstPackageWriter methodsFor: 'information-retrieval' stamp: 'tfel 9/7/2009 20:36'!
requiredPackages

	^ (MCPackage named: self packageName) workingCopy requiredPackages! !

!GCGstPackageWriter methodsFor: 'stream-writing' stamp: 'tfel 9/10/2009 13:44'!
requires

	self requiredPackages do: [:pkg | self require: pkg]! !

!GCGstPackageWriter methodsFor: 'stream-writing' stamp: 'tfel 9/14/2009 00:58'!
tests
	"Prepare the tests for usage with Gnu Smalltalk"
	| testClasses testCases |
	testClasses := self classes select: [:class | class allSuperclasses includes: TestCase].
	testCases := testClasses inject: String new into: [:s :class |
		s, self packageName, '.', class name asString, newline asString].
	self packageXmlStream nextPutAll: '<test>', newline asString.
	testClasses do: [:class | self fileIn: class].
	self putAttribute: 'sunit' with: testCases.
	self packageXmlStream nextPutAll: '</test>', newline asString.! !

Object subclass: #GCMapper
	instanceVariableNames: 'systemOrganizer packageName repoDir files'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Gitocello-Core'!

!GCMapper commentStamp: 'tfel 9/10/2009 11:56' prior: 0!
I am used to file out a package to a repository. I do not care at all what kind of repository. 
'repoDir' and 'packageName' are the only options that should be set on me.
You can use my 'files' field to find out which files I have filed out during my lifetime.

I just map packages and classes to files. Like so:
The packages and classes
		Package (Class1)
		Package-Core (Class2)
		Package-Base (Class3, Class4)
become
		Package/
			|- Core/
				|- Class2.st
			|- Base/
				|- Class3.st
				|- Class4.st
			|- Class1.st!

!GCMapper class methodsFor: 'instance creation' stamp: 'tfel 9/6/2009 20:49'!
newFor: aPackage

	^ self basicNew
		packageName: aPackage;
		initialize;
		yourself! !

!GCMapper methodsFor: 'fileOut' stamp: 'tfel 9/7/2009 20:27'!
createFolder: aSubfolder

	(repoDir directoryExists: aSubfolder)
		ifFalse: [repoDir createDirectory: aSubfolder]! !

!GCMapper methodsFor: 'fileOut' stamp: 'tfel 9/7/2009 20:26'!
fileOutCategory: aCategory
	"This creates a sub-folder in the repository for the categories classes"
	| subfolder |
	subfolder := (aCategory asString findBetweenSubStrs: '-') last.
	self createFolder: subfolder.
	(systemOrganizer superclassOrder: aCategory) do: [:each | 
		self 
			fileOutClass: each 
			in: (repoDir directoryNamed: subfolder) pathName]! !

!GCMapper methodsFor: 'fileOut' stamp: 'tfel 9/10/2009 11:53'!
fileOutClass: aClass in: aPath
	"This files out the class in the according sub-folder"
	| stream path |
	stream := WriteStream on: (String new: 100).
	aClass fileOutOn: stream moveSource: false toFile: 0.
	path := (aPath, FileDirectory pathNameDelimiter asString, aClass name).
	self writeSourceCodeFrom: stream to: path! !

!GCMapper methodsFor: 'fileOut' stamp: 'tfel 9/10/2009 10:28'!
fileOutExtensions: extensionMethods
	"For each extended class collect the extension Methods and file them out"
	| dict |
	self createFolder: 'Extensions'.
	dict := Dictionary new.
	extensionMethods do: [:each | 
		dict at: each classSymbol ifAbsentPut: OrderedCollection new.
		(dict at: each classSymbol) add: each methodSymbol].
	dict keysDo: [:key || stream file |
		stream := WriteStream on: (String new: 1000).
		file := (repoDir directoryNamed: 'Extensions') pathName, 
				FileDirectory pathNameDelimiter asString, 
				key asString.
		(dict at: key) do: [:method |
			(Smalltalk classNamed: key) 
				printMethodChunk: method withPreamble: true
				on: stream moveSource: false toFile: 0].
		self writeSourceCodeFrom: stream to: file]! !

!GCMapper methodsFor: 'fileOut' stamp: 'tfel 9/10/2009 11:55'!
fileOutPackage
	"Files out the entire package into a folder structure"
	| packageInfo |
	packageInfo := PackageInfo named: self packageName.
	packageInfo systemCategories do: [:category | self fileOutCategory: category].
	packageInfo extensionMethods 
		ifNotEmpty: [self fileOutExtensions: packageInfo extensionMethods].
	! !

!GCMapper methodsFor: 'accessing' stamp: 'tfel 9/10/2009 11:54'!
files

	^ files! !

!GCMapper methodsFor: 'initialize-release' stamp: 'tfel 9/10/2009 11:55'!
initialize

	super initialize.
	files := Set new.
	systemOrganizer := Smalltalk organization! !

!GCMapper methodsFor: 'accessing' stamp: 'tfel 9/6/2009 20:33'!
packageName
	"Answer the value of packageName"

	^ packageName! !

!GCMapper methodsFor: 'accessing' stamp: 'tfel 9/6/2009 20:33'!
packageName: anObject
	"Set the value of packageName"

	packageName := anObject! !

!GCMapper methodsFor: 'accessing' stamp: 'tfel 9/7/2009 02:29'!
repoDir

	^ repoDir! !

!GCMapper methodsFor: 'accessing' stamp: 'tfel 9/13/2009 10:03'!
repoDir: aFileDirectory

	aFileDirectory assureExistence.
	repoDir := aFileDirectory! !

!GCMapper methodsFor: 'fileOut' stamp: 'mh 5/12/2010 15:57'!
writeSourceCodeFrom: aStream to: aFile
	"This writes the source code and adds to files"
	| converter f fileName |
	aStream contents isAsciiString 
		ifTrue: [converter := MacRomanTextConverter new]
		ifFalse: [converter := UTF8TextConverter new].
	fileName := aFile, (FileDirectory dot, FileStream st).
	f := MultiByteFileStream new open: fileName forWrite: true.
	f ifNil: [^ self error: 'Cannot open file'].
	f lineEndConvention: #lf.
	(converter isMemberOf: UTF8TextConverter)
		ifTrue: [f binary.
			UTF8TextConverter writeBOMOn: f].
	f text.
	f converter: converter.
	f nextPutAll: aStream contents.
	f close.
	files add: fileName! !

Object subclass: #GCPackage
	instanceVariableNames: 'packageName packageClasses lastCommit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Gitocello-Core'!

!GCPackage class methodsFor: 'instance creation' stamp: 'tfel 9/20/2009 14:24'!
newFor: aPackage

	^ self new
		packageName: aPackage;
		yourself
! !

!GCPackage methodsFor: 'accessing' stamp: 'tfel 9/20/2009 14:31'!
classes
	"This converts, then sorts the class names, then finds the classes. Expensive, but run basically 
	only on intialization of the package and for the browser, which is slow anyway"
	| packageInfo |
	packageInfo := (PackageInfo named: self packageName).
	^ ((packageInfo classes union: packageInfo extensionClasses)
		collect: [:class | class name asString]) asSortedCollection
			collect: [:className | Smalltalk classNamed: className]! !

!GCPackage methodsFor: 'accessing' stamp: 'tfel 9/20/2009 13:00'!
lastCommit
	"Answer the value of lastCommit"

	^ lastCommit! !

!GCPackage methodsFor: 'accessing' stamp: 'tfel 9/20/2009 13:00'!
lastCommit: anObject
	"Set the value of lastCommit"

	lastCommit := anObject! !

!GCPackage methodsFor: 'accessing' stamp: 'tfel 9/20/2009 14:25'!
packageClasses
	"Answer the value of packageClasses"

	packageClasses ifNil: [packageClasses := self classes].
	^ packageClasses! !

!GCPackage methodsFor: 'accessing' stamp: 'tfel 9/20/2009 12:50'!
packageClasses: anObject
	"Set the value of packageClasses"

	packageClasses := anObject! !

!GCPackage methodsFor: 'accessing' stamp: 'tfel 9/20/2009 14:23'!
packageName
	"Answer the value of packageName"

	^ packageName! !

!GCPackage methodsFor: 'accessing' stamp: 'tfel 9/20/2009 14:23'!
packageName: anObject
	"Set the value of packageName"

	packageName := anObject! !

Object subclass: #GCRegistry
	instanceVariableNames: 'git'
	classVariableNames: 'Repositories RepositoryRoot'
	poolDictionaries: ''
	category: 'Gitocello-Core'!

GCRegistry class
	instanceVariableNames: 'instance'!

!GCRegistry commentStamp: 'tfel 9/10/2009 11:56' prior: 0!
In my class I keep all the information on where to create/find git repositories in the file system (RepositoryRoot) and which Repositories have been created and how far they are along compared to their Monticello history.

My instance (of which there is only one) is used to create, remove and update repositories 
through the interface exposed in the 'commands' category.

I am well aware of the conversion to Gnu Smalltalk going on here, and I call the appropriate classes to do the conversion.!

GCRegistry class
	instanceVariableNames: 'instance'!

!GCRegistry class methodsFor: 'accessing' stamp: 'tfel 9/20/2009 13:20'!
at: aPackage

	^ self repositories at: aPackage! !

!GCRegistry class methodsFor: 'class initialization' stamp: 'tfel 9/7/2009 03:42'!
createDirectoryStructure: aString
	"Create the directory structure beneath the current image"
	| repoDir |
	repoDir := FileDirectory default.
	(aString findBetweenSubStrs: FileDirectory pathNameDelimiter asString)
		do: [:each |
			(repoDir directoryExists: each)
				ifFalse: [repoDir createDirectory: each].
			repoDir := repoDir directoryNamed: each].
	^ repoDir! !

!GCRegistry class methodsFor: 'error handling' stamp: 'tfel 9/9/2009 13:43'!
doesNotUnderstand: aMessage

	(self new respondsTo: aMessage selector)
		ifTrue: [^ self instance 
					perform: aMessage selector 
					withArguments: aMessage arguments].
	^ super doesNotUnderstand: aMessage! !

!GCRegistry class methodsFor: 'class initialization' stamp: 'mh 5/10/2010 15:27'!
initialize
	
	super initialize.
	Smalltalk addToStartUpList: self. 
	self startUp.
	self instance: nil.! !

!GCRegistry class methodsFor: 'class variables' stamp: 'tfel 9/7/2009 03:31'!
instance
	
	^ instance! !

!GCRegistry class methodsFor: 'class variables' stamp: 'tfel 9/7/2009 03:31'!
instance: anObject
	
	instance := anObject! !

!GCRegistry class methodsFor: 'class initialization' stamp: 'tfel 9/9/2009 13:44'!
new
	"One global Registry is enough"
	^ self instance 
		ifNil: [instance := super new]
		ifNotNil: [instance]! !

!GCRegistry class methodsFor: 'class variables' stamp: 'mh 5/10/2010 15:23'!
repositories

	Repositories ifNil: [Repositories := Dictionary new].
	^ Repositories ! !

!GCRegistry class methodsFor: 'class variables' stamp: 'tfel 9/7/2009 02:39'!
repositories: aDictionary

	Repositories := aDictionary! !

!GCRegistry class methodsFor: 'class variables' stamp: 'tfel 9/7/2009 03:09'!
repositoryRoot
	"Return the FileDirectory"
	^ RepositoryRoot! !

!GCRegistry class methodsFor: 'class variables' stamp: 'tfel 9/7/2009 03:12'!
repositoryRoot: aStringOrDirectory
	"Set the FileDirectory either directly or from String"
	RepositoryRoot := aStringOrDirectory isString 
		ifTrue: [self createDirectoryStructure: aStringOrDirectory]
		ifFalse: [self createDirectoryStructure: aStringOrDirectory pathName]
			! !

!GCRegistry class methodsFor: 'class initialization' stamp: 'mh 5/10/2010 15:28'!
startUp

	self 
		repositoryRoot: 'package-cache', FileDirectory slash, 'git-repositories'.
	(self repositories keys copy do: [:each |
			(self repositoryRoot directoryNames includes: each)
				ifFalse: [Repositories removeKey: each]]).! !

!GCRegistry class methodsFor: 'class variables' stamp: 'tfel 9/10/2009 09:27'!
tracksPackage: aPackageNameOrMCPackage

	^ (self repositories keys includes: aPackageNameOrMCPackage)
		or: [self repositories keys includes: aPackageNameOrMCPackage name]! !

!GCRegistry methodsFor: 'accessing' stamp: 'tfel 9/20/2009 13:01'!
at: aPackage

	^ self repositories at: aPackage! !

!GCRegistry methodsFor: 'commands' stamp: 'TF 5/15/2010 17:56:44.767'!
commit: aPackage
	"This is part of the class interface - try not to break it"
	self 
		createFilesFor: aPackage;
		run: #add
			in: aPackage asString
			with: #();
		run: #commit:
			in: aPackage asString
			with: (Array with: (self commitMessagesFor: aPackage)).! !

!GCRegistry methodsFor: 'monticello-helpers' stamp: 'tfel 4/25/2010 17:15:59.569'!
commitMessagesFor: aPackage
	"Creates a git-commit-msg from the non-commited Monticello versions"
	| cr messages |
	cr := Character lf asString.
	messages := WriteStream on: (String new: 100).
	((MCPackage named: aPackage) 
		workingCopy ancestry breadthFirstAncestors 
			copyUpTo: (self at: aPackage) lastCommit)
				do: [:next |
					messages nextPutAll: cr, cr, next date asString, ': ', 
						next author, ' from Squeak: ', next message].
	(self at: aPackage)
		lastCommit: ((MCPackage named: aPackage) workingCopy ancestry ancestors 
			ifEmpty: [nil]
			ifNotEmpty: [:o | o first]).
	^ self escapeForBash: messages contents
		! !

!GCRegistry methodsFor: 'fileOut' stamp: 'tfel 9/13/2009 11:56'!
createFilesFor: aPackage
	"Create and convert source to Gnu Smalltalk syntax. Als create a package.xml"
	| files |
	files := (GCMapper newFor: aPackage)
		repoDir: (RepositoryRoot directoryNamed: aPackage);
		fileOutPackage;
		files.
	files do: [:file | GCGstConvertCommand convert: file from: 'squeak' to: 'gst'].
	(GCGstPackageWriter newFor: aPackage)
		repoDir: (RepositoryRoot directoryNamed: aPackage);
		fileOutPackageXml! !

!GCRegistry methodsFor: 'commands' stamp: 'tfel 9/20/2009 13:02'!
createRepositoryFor: aPackage
	"This will do everything in its power to commit that package to git!!"
	(Repositories includesKey: aPackage) ifFalse: [
		Repositories add: (aPackage -> (GCPackage newFor: aPackage)).
		self createFilesFor: aPackage.
		self run: #init in: aPackage asString].
	self commit: aPackage! !

!GCRegistry methodsFor: 'commands' stamp: 'tfel 4/25/2010 17:20:55.312'!
dumpImage
	"Dump all packages currently in the system"
	(SmalltalkImage current organization categories
	collect: [:c | c asString copyUpTo: $-]) asSet
		do: [:package | GCRegistry new createRepositoryFor: package].! !

!GCRegistry methodsFor: 'monticello-helpers' stamp: 'tfel 9/10/2009 09:41'!
escapeForBash: aString

	^ (((aString 
		replaceAll: Character cr with: Character lf)
		replaceAll: $!! with: $.)
		replaceAll: $" with: $')
		replaceAll: $$ with: $S
		! !

!GCRegistry methodsFor: 'initialize-release' stamp: 'tfel 9/7/2009 03:32'!
initialize

	super initialize.
	git := GCGitWrapper new! !

!GCRegistry methodsFor: 'commands' stamp: 'TF 5/15/2010 17:59:51.201'!
pull: aPackage
	"This might be removed at some time in the future"
	self run: #pull in: aPackage asString! !

!GCRegistry methodsFor: 'commands' stamp: 'tfel 9/8/2009 20:17'!
push: aPackage
	"This might be removed at some time in the future"
	self run: #push in: aPackage asString! !

!GCRegistry methodsFor: 'commands' stamp: 'tfel 9/8/2009 20:27'!
removeRepositoryFor: aPackage
	"This will not touch the filesystem, only our registry"
	Repositories removeKey: aPackage ifAbsent: []! !

!GCRegistry methodsFor: 'accessing' stamp: 'tfel 9/7/2009 03:33'!
repositories

	^ Repositories! !

!GCRegistry methodsFor: 'helpers' stamp: 'tfel 9/8/2009 19:57'!
run: aGitCommand in: aPackage
	
	self run: aGitCommand in: aPackage with: (Array new: 0)
		! !

!GCRegistry methodsFor: 'helpers' stamp: 'tfel 9/8/2009 19:57'!
run: aGitCommand in: aPackage with: anArgumentsArray
	"Set the details we need and run"
	git 
		localPath: RepositoryRoot pathName, 
					FileDirectory pathNameDelimiter asString, 
					aPackage;
		perform: aGitCommand withArguments: anArgumentsArray
		! !

!GCRegistry methodsFor: 'monticello-helpers' stamp: 'TF 5/15/2010 18:01:54.402'!
storeVersion: aWorkingCopy

	| package |
	package := aWorkingCopy package name.
	self 
		pull: package;
		commit: package;
		push: package.
	! !

SystemWindow subclass: #GCRepositoryBrowser
	instanceVariableNames: 'repositoryIndex selectedClassIndex classList selectedClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Gitocello-Morphic'!

!GCRepositoryBrowser class methodsFor: 'as yet unclassified' stamp: 'tfel 9/20/2009 15:18'!
open

	(self new) 
		createWindow; 
		openInWorld! !

!GCRepositoryBrowser methodsFor: 'as yet unclassified' stamp: 'tfel 4/26/2010 22:23'!
classList

	
	classList ifNil: [
		classList := GCRegistry repositories
			ifEmpty: [#()]
			ifNotEmpty: [(GCRegistry at: self selectedRepository) classes]].
	^ classList! !

!GCRepositoryBrowser methodsFor: 'accessing' stamp: 'tfel 9/20/2009 15:02'!
classList: anObject
	"Set the value of classList"

	classList := anObject! !

!GCRepositoryBrowser methodsFor: 'as yet unclassified' stamp: 'tfel 9/20/2009 15:04'!
classListMap

	^ self classList
		collect: [:class | self packageClasses includes: class]! !

!GCRepositoryBrowser methodsFor: 'as yet unclassified' stamp: 'tfel 9/20/2009 14:08'!
contents

	^ self selectedRepository! !

!GCRepositoryBrowser methodsFor: 'as yet unclassified' stamp: 'tfel 10/2/2009 21:37'!
createWindow
	
	| packageList classList repositoryUrlEntry |
	(repositoryUrlEntry := PluggableTextMorph new)
		on: self
		text: #repositoryRoot
		accept: #repositoryRoot:
		readSelection: nil
		menu: #annotationPaneMenu:shifted:.
	(packageList := PluggableListMorph new)
		on: self list: #repositoryList
		selected: #repositoryIndex changeSelected: #repositoryIndex:
		menu: #memberMenu:shifted: keystroke: nil.
	(classList := PluggableListMorphOfMany new)
		on: self list: #classList 
		primarySelection: #selectedClassIndex changePrimarySelection: #selectedClassIndex:
		listSelection: #selectedClassesAt: changeListSelection: #selectedClassesAt:put: 
		menu: #classMenu keystroke: nil.
	repositoryUrlEntry color: self defaultBackgroundColor.
	classList color: self defaultBackgroundColor.
	packageList color: self defaultBackgroundColor.
	self addMorph: repositoryUrlEntry frame: (0@0.01 corner: 1.0@0.08).
	self addMorph: packageList frame: (0@0.1 corner: 0.5@1.0).
	self addMorph: classList frame: (0.5@0.1 corner: 1.0@1.0).

	self setLabel: 'Package Git Repository Mirrors'! !

!GCRepositoryBrowser methodsFor: 'as yet unclassified' stamp: 'tfel 4/26/2010 22:21'!
initialize

	super initialize.
	self 
		repositoryIndex: 1;
		selectedClassIndex: 1;
		selectedClasses: self classListMap! !

!GCRepositoryBrowser methodsFor: 'accessing' stamp: 'tfel 4/26/2010 22:22'!
packageClasses
	
	^ GCRegistry repositories 
		ifEmpty: [#()]
		ifNotEmpty: [(GCRegistry at: self selectedRepository) packageClasses].! !

!GCRepositoryBrowser methodsFor: 'accessing' stamp: 'tfel 9/20/2009 14:01'!
repositoryIndex
	"Answer the value of repositoryIndex"

	^ repositoryIndex! !

!GCRepositoryBrowser methodsFor: 'accessing' stamp: 'tfel 9/20/2009 14:45'!
repositoryIndex: anObject
	"Set the value of repositoryIndex"

	repositoryIndex := anObject.
	classList := nil! !

!GCRepositoryBrowser methodsFor: 'as yet unclassified' stamp: 'tfel 9/20/2009 14:03'!
repositoryList

	^ GCRegistry repositories keys asOrderedCollection! !

!GCRepositoryBrowser methodsFor: 'accessing' stamp: 'tfel 10/2/2009 21:35'!
repositoryRoot

	^ GCRegistry repositoryRoot pathName! !

!GCRepositoryBrowser methodsFor: 'accessing' stamp: 'tfel 10/2/2009 21:34'!
repositoryRoot: aString

	^ GCRegistry repositoryRoot: aString! !

!GCRepositoryBrowser methodsFor: 'accessing' stamp: 'tfel 9/20/2009 14:51'!
selectedClassIndex
	"Answer the value of selectedClassIndex"

	^ selectedClassIndex! !

!GCRepositoryBrowser methodsFor: 'accessing' stamp: 'tfel 9/20/2009 14:51'!
selectedClassIndex: anObject
	"Set the value of selectedClassIndex"

	selectedClassIndex := anObject! !

!GCRepositoryBrowser methodsFor: 'accessing' stamp: 'tfel 9/20/2009 15:02'!
selectedClasses
	"Answer the value of selectedClasses"

	^ selectedClasses! !

!GCRepositoryBrowser methodsFor: 'accessing' stamp: 'tfel 9/20/2009 15:02'!
selectedClasses: anObject
	"Set the value of selectedClasses"

	selectedClasses := anObject! !

!GCRepositoryBrowser methodsFor: 'as yet unclassified' stamp: 'tfel 9/20/2009 14:58'!
selectedClassesAt: anIndex

	^ selectedClasses at: anIndex! !

!GCRepositoryBrowser methodsFor: 'as yet unclassified' stamp: 'tfel 9/20/2009 15:16'!
selectedClassesAt: anIndex put: aValue

	selectedClasses at: anIndex put: (aValue = true).
	self 
		changed: #selectedClassIndex;
		updatePackageClasses! !

!GCRepositoryBrowser methodsFor: 'as yet unclassified' stamp: 'tfel 9/20/2009 14:10'!
selectedRepository

	^ self repositoryList at: self repositoryIndex! !

!GCRepositoryBrowser methodsFor: 'accessing' stamp: 'tfel 9/20/2009 15:15'!
updatePackageClasses

	(GCRegistry at: self selectedRepository)
		packageClasses: (self classList
			select: [:class |
				self selectedClasses at: (self classList indexOf: class)])! !
GCRegistry initialize!
